﻿var Player =
{
    selected_channel: 0,
	selected_page: 0,
	chan_array_index: 0,
	plugin : null,
	mwPlugin: null,
    state : -1,
    size: 0,
    STOPPED : 0,
    PLAYING_LIVE : 1,
	originalSource : null,
	statusmessage : null,
	PLAYING_VOD : 4,
	PAUSA_VOD : 5,
	vod_duration : 0,
	vod_one_percent : 0,
	vod_current_time : 0,
}

Player.init = function()
{
    var success = true;
    
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");
    
    if (!this.plugin)
    {
         success = false;
    }

	this.mwPlugin = document.getElementById("pluginObjectTVMW");
	if (!this.mwPlugin || !this.mwPlugin.GetSource) 
	{
		success = false;
	} 
	else 
	{
		this.originalSource = this.mwPlugin.GetSource();
		this.mwPlugin.SetMediaSource();
	}

		
	this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
	this.plugin.OnCurrentPlayTime = 'Player.CurrentTime';
	this.plugin.OnStreamInfoReady = 'Player.OnStreamInfoReady';
	
	this.plugin.OnConnectionFailed = 'Player.OnConnectionFailed';
	this.plugin.OnNetworkDisconnected = 'Player.OnNetworkDisconnected';
	this.plugin.OnStreamNotFound = 'Player.OnStreamNotFound';
	this.plugin.OnRenderError = 'Player.OnRenderError';
	this.plugin.onServerError = 'Player.onServerError';
		
    return success;
}

Player.matrixReload = function()
{
	Main.PlayChannel();
	Display.status("RELOAD");
}

// Global functions called directly by the player 
Player.OnConnectionFailed = function()
{
    Display.status("Connection Failed!");
	//Player.matrixReload();
	ConsoleLog('OnConnectionFailed');
}

Player.OnNetworkDisconnected = function()
{
	Display.status("Network Disconnected!");
	//Player.playVideo();
}

Player.OnStreamNotFound = function()
{
	Display.status("Stream Not Found!");
	//Player.playVideo();
}

Player.OnStreamInfoReady = function()
{
	Player.state = Player.PLAYING_LIVE;
	alert('Player.state ' + Player.state);
	Player.setSize(Player.size, 0);
	Player.ShowResolution();
	if(Player.plugin.GetDuration()>0)
	{
		KeyHandler.setFocus(Main.VideothekPlayer_ID);
		Player.state = Player.PLAYING_VOD;
	}

	alert('Player.plugin.GetDuration ' + Player.plugin.GetDuration());
	alert('Player.state ' + Player.state);
}
		
Player.OnRenderError = function()
{
    Display.status("Render Error!");
	//Player.playVideo();
}

Player.onServerError = function()
{
    //Player.matrixReload();
	Display.status("Server Error!");
	//Player.playVideo();
}

getBandwidth = function(bandwidth) { ConsoleLog("getBandwidth " + bandwidth); }

onDecoderReady = function() { ConsoleLogt("onDecoderReady"); }

onRenderError = function() { ConsoleLog("onRenderError"); }

Player.onBufferingStart = function()
{
    Display.status("Buffering...");
	//ConsoleLog("Buffering...");
	widgetAPI.putInnerHTML(document.getElementById("player_time"), "");
}

Player.onBufferingProgress = function(percent)
{
    Display.status("Buffering:" + percent + "%");
	//ConsoleLog("Buffering:" + percent + "%");
}

Player.onBufferingComplete = function()
{
	Display.status("Buffering Complete");
	ConsoleLog("Buffering Complete");
}

Player.secToStr =function(sec)
{
   sec = parseInt(sec);
   minuten = parseInt(sec/60);
   sec = sec%60;
   stunden = parseInt(minuten/60);
   minuten = minuten%60;
   return (stunden > 10 ? stunden : ("0" + stunden)) + ":" + (minuten > 10 ? minuten : ("0" + minuten)) + ":" + (sec > 10 ? sec : ("0" + sec));
}

Player.CurrentTime = function(time)
{
	
	if(Player.plugin.GetDuration()>0)
	{
		document.getElementById("ch_progressbar").style.display="block";
		this.vod_current_time = parseInt(time);
		this.vod_duration = Player.plugin.GetDuration();
		this.vod_one_percent = parseInt(this.vod_duration/100);
		//VideothekPlayer.UpdatePlayerStatusbar();
		var elapsed_time_percent = parseInt(Player.vod_current_time/ Player.vod_one_percent);
		var elapsed_time = Player.secToStr(Player.vod_current_time/1000);
		var vod_duration_time = Player.secToStr(this.vod_duration/1000);
		var time_left = Player.secToStr((Player.vod_duration - Player.vod_current_time)/1000);
		widgetAPI.putInnerHTML(document.getElementById("player_time"), elapsed_time + "<br>" + vod_duration_time);
		Player.state=Player.PLAYING_VOD;

		if(elapsed_time_percent)
		{
			document.getElementById("ch_percent").style.width=parseInt(elapsed_time_percent)+"%";
		}
	}
	else
	{
		Player.state=Player.PLAYING_LIVE;
		widgetAPI.putInnerHTML(document.getElementById("player_time"), '');
		document.getElementById("ch_progressbar").style.display="none";
	}
	Player.updateStatusbar();

	//alert('----------- Player.state' + Player.state);
	
}

Player.updateStatusbar= function()
{
    if(Player.state == Player.PLAYING_VOD)
	{
		document.getElementById("help_navi_player").style.display="none";
		document.getElementById("help_navi_vod_player").style.display="block";
	}
    if(Player.state == Player.PLAYING_LIVE)
	{
		document.getElementById("help_navi_player").style.display="block";
		document.getElementById("help_navi_vod_player").style.display="none";
	}
}
	
Player.deinit = function()
{
	if (this.plugin)
	{
		this.plugin.Stop();
	}
	ConsoleLog("Player deinit !!! " ); 
	if(this.mwPlugin != null)
		this.mwPlugin.SetMediaSource(this.originalSource);
	

}

Player.setVideoURL = function(url)
{
    this.url = url;
    ConsoleLog("URL = " + this.url);
}

Player.playVideo = function()
{	
		
	if (this.url == null)
    {
        ConsoleLog("No videos to play");
    }
    else
    {
		this.plugin.Stop();
		pluginAPI.setOffScreenSaver();
		alert('Screen.getModeD2()' + Screen.getModeD2());
		var d2mode = Screen.getModeD2();
		if(d2mode==0)
			this.plugin.Play( this.url );
		else
		{
			this.plugin.InitPlayer(this.url);
			this.plugin.SetPlayerProperty(2, "3", d2mode)
			this.plugin.StartPlayback();
		}
        Audio.plugin.SetSystemMute(false); 
		Player.state = Player.PLAYING_LIVE;
    }
	ConsoleLog("Play");
	//document.getElementById("old_help").style.display="none";
}


Player.getState = function()
{
    return this.state;
}

stopPlayer = function()
{
    Player.stopVideo();
}

Player.stopVideo = function()
{

	Display.status("Stop");
	if (this.state != this.STOPPED)
    {
        this.state = this.STOPPED;
        Display.status("Stop");
        this.plugin.Stop();
        
    }
    else
    {
        alert("Ignoring stop request, not in correct state");
    }
}

Player.ShowResolution = function()
{
	var h=this.plugin.GetVideoHeight();
	var w=this.plugin.GetVideoWidth();
	var res = "<center>" + w + "X" + h + "</center>";
	widgetAPI.putInnerHTML(document.getElementById("resolution"), res);
			
}		

Player.setTottalBuffer = function(buffer) 
{ 
	var new_buffer = this.plugin.setTotalBufferSize(buffer);
	ConsoleLog("setTottalBuffer " + new_buffer); 
	Display.status(new_buffer);

}

Player.setInitialBuffer = function(buffer) 
{ 
	var new_buffer = this.plugin.setInitialBuffer(buffer);
	ConsoleLog("setInitialBuffer " + new_buffer); 
}

Player.setSize=function(mode, show)
{
	if (this.state != this.STOPPED)
	{
		this.size=mode;

		var h=this.plugin.GetVideoHeight();
		var w=this.plugin.GetVideoWidth();
		switch(mode)
		{
			case 0 :
				//[16x9]
				if(show>0)
					Display.status('16x9 FULL');
				this.plugin.SetCropArea(0, 0, w, h);
				this.plugin.SetDisplayArea(0, 0, 960, 540);
				break;
				
			case 1 :
				var z = 960/w;//0,75
				var m = parseInt(z*h);
				var y = parseInt((540-m)/2);
				if(w/h>1.777)
				{
					if(show>0)
						Display.status('16x9 ORIGINAL');
					this.plugin.SetCropArea(0, 0, w, h);
					this.plugin.SetDisplayArea(0, y, 960, m);
				}
				else
				{
					if(show>0)
						Display.status('4x3 KINOZOOM');
					this.plugin.SetCropArea(0, 70, w, 436);
					this.plugin.SetDisplayArea(0, 0, 960, 540);
				}
				break;
			
			case 2 :
				if(show>0)
					Display.status('4x3');
				this.plugin.SetCropArea(0, 0, w, h);
				this.plugin.SetDisplayArea(120,0,720,540);
				break;
			
			case 3 :
				if(show>0)
					Display.status('4x3->16x9 ZOOM');
				var m = parseInt(h/1.33);//576->432
				var y = parseInt((h-m)/2);
				this.plugin.SetCropArea(0, y, w, m);
				this.plugin.SetDisplayArea(0, 0, 960, 540);
				break;		   

		}
	}
}

//VIDEOTHEK
Player.MinutesJump = function(minutes) 
{
	var sign = "";
	if(minutes>0)
		var sign = "+";
	this.statusmessage =sign + minutes + " мин.";
	if (minutes > 0) {
		this.plugin.JumpForward(minutes*60);    
	} else if (minutes < 0) {
		this.plugin.JumpBackward(minutes*60*-1);
	}
	Display.status(this.statusmessage);
}

Player.PercentJump = function(percent) 
{
	this.statusmessage = percent*10 + "%";
	var jump_time = 0;
	if(percent)
		jump_time = parseInt((this.vod_current_time + this.vod_one_percent*percent*10)/1000);
	
	var now_percent = parseInt(this.vod_current_time/this.vod_one_percent);
	var jump_to_percent = percent*10 - now_percent;
	var jump_to_minutes = (this.vod_one_percent*jump_to_percent)/1000;
	
	if (jump_to_minutes > 0) {
		this.plugin.JumpForward(jump_to_minutes);    
	} else if (jump_to_minutes < 0) {
		this.plugin.JumpBackward(jump_to_minutes*-1);
	}
	Display.status(this.statusmessage);
}

Player.resumeVideo = function()
{
	if (this.state != this.STOPPED)
	{
		this.state = this.PLAYING_VOD;
		this.plugin.Resume();
		document.getElementById("vod_pause").style.display="";
		document.getElementById("vod_play").style.display="none";
		Display.status('PLAY');
	}
}

Player.pauseVideo = function()
{
	if (this.state != this.STOPPED)
	{
		this.state = this.PAUSA_VOD;
		this.plugin.Pause();
		document.getElementById("vod_pause").style.display="none";
		document.getElementById("vod_play").style.display="";
		document.getElementById("statusbar").style.display="";
		widgetAPI.putInnerHTML(Display.statusDiv, "PAUSE");
	}
}
Player.getSize=function() {return this.size;}